using MediatR;
using Modules.Library.Application.Gateways;
using Modules.Library.Domain.Entities.MediaContent.Items.Anime;

namespace Modules.Library.Application.Commands.Anime.Episode.Properties.Description;

public class AddDescriptionCommand : IRequest<Unit>
{
    public Guid TitleId { get; set; }
    public Guid SeasonId { get; set; }
    public Guid EpisodeId { get; set; }
    public Guid LanguageId { get; set; }
    public string Value { get; set; } = default!;
    public bool IsOriginal { get; set; }

}

public class AddDescriptionCommandHandler(IAnimeTitleGateway titleGateway, ILanguageGateway languageGateway) : IRequestHandler<AddDescriptionCommand, Unit>
{
    public async Task<Unit> Handle(AddDescriptionCommand request, CancellationToken cancellationToken)
    {
        var title = await titleGateway.GetById(request.TitleId);
        if (!await languageGateway.IsLanguageExists(request.LanguageId)) throw new Exception();
        var season = title.Items.OfType<AnimeSeason>().FirstOrDefault(q => q.Id == request.SeasonId) ??
            throw new Exception("Season not found");
        var episode = season.Episodes.FirstOrDefault(q => q.Id == request.EpisodeId) ??
            throw new Exception("Episode not found");
        if (request.IsOriginal) episode.CommonProperties.AddOriginalDescription(request.LanguageId, request.Value);
        else episode.CommonProperties.AddNotOriginalDescription(request.LanguageId, request.Value);
        await titleGateway.Update(title);
        return Unit.Value;
    }
}